
// This macro gets the high and low values of the 8 surrounding pixels. Register esi
// is assumed to point one line above the target pixel and reg ebx is assumbed to 
// contain the source pitch. Defined value BPP must be set to bytes per pixel,
// either 1 for YV12 or 2 for YUY2. Answer returned in mm0, mm1
#define GetMinMax \
__asm { \
		__asm movq	mm0, qword ptr[esi-BPP]			/* Above left, mm0 will hold min */ \
		__asm movq	mm1, mm0						/* Above left, mm1 will hold max */ \
		__asm pminub mm0, qword ptr[esi]			/* above center */ \
		__asm pmaxub mm1, qword ptr[esi]			/* above center */ \
		__asm pminub mm0, qword ptr[esi+BPP]		/* above right */ \
		__asm pmaxub mm1, qword ptr[esi+BPP]		/* above right */ \
		__asm pminub mm0, qword ptr[esi+ebx-BPP]	/* left */ \
		__asm pmaxub mm1, qword ptr[esi+ebx-BPP]	/* left */ \
		__asm pminub mm0, qword ptr[esi+ebx+BPP]	/* right */ \
		__asm pmaxub mm1, qword ptr[esi+ebx+BPP]	/* right */ \
		__asm pminub mm0, qword ptr[esi+2*ebx-BPP]	/* bottom left */ \
		__asm pmaxub mm1, qword ptr[esi+2*ebx-BPP]	/* bottom left */ \
		__asm pminub mm0, qword ptr[esi+2*ebx]		/* bottom center */ \
		__asm pmaxub mm1, qword ptr[esi+2*ebx]		/* bottom center */ \
		__asm pminub mm0, qword ptr[esi+2*ebx+BPP]	/* bottom right */ \
		__asm pmaxub mm1, qword ptr[esi+2*ebx+BPP]	/* bottom right */ \
}

const __int64 YMask = 0x00ff00ff00ff00ff;
const __int64 UVMask = 0xff00ff00ff00ff00;

